function [M,XO] = delete_labels(L,I,XI)
% [M,XO] = delete_labels(L,I,XI)
%    L is a list of <start> <end> <labelindex> rows.
%    Remove all instances of <labelindex> I 
%    and extend surrounding labels 50% into that time.
%    XI is a cell array of per-row extra information; XO is
%    corresponding output entries.
% 2012-03-11 Dan Ellis dpwe@ee.columbia

if nargin < 3; XI = []; end

if length(XI) == 0; XI = cell(size(L,1),1); end

% convert to <starttime> <label> entries

[L2,XO] = lab3col_to_lab2col(L,XI);
nlabin = size(L2,1);

ix = find(L2(:,2)==I);

L2(ix+1,1) = 0.5*(L2(ix,1)+L2(ix+1,1));
% should be OK because final item in L2 is "no label", so ix < length(L2)

% fixup first label - all the way to the start
if length(ix) > 0 && ix(1) == 1
  L2(2,1) = L2(1,1);
end

% Remove all the overwritten label rows
kpx = find(L2(:,2) ~= I);
L2 = L2(kpx,:);
XO = XO(kpx);

% Back into 3 col
[M,XO] = lab2col_to_lab3col(L2,XO);

