function model = gmm_estmerge(data,comps,SMALLESTTHRESH, KLTHRESH,VERBOSE)
% model = gmm_estmerge(data,comps,SMALLESTTHRESH, KLTHRESH,VERBOSE)
%     Estimate a GMM model of rows of <data>, using (initiall)
%     <comps> components.  But then put it through a merging
%     procedure, so overlapped components are merged.
% 2012-04-26 Dan Ellis dpwe@ee.columbia.edu  refactor of findNT.m

if nargin < 2;  comps = 16;  end

% Clusters whose volume is within this factor of the smallest are
% candidates for merging seeds
if nargin < 3;  SMALLESTTHRESH = 2.0; end

% We merge components if their likelihood under the cluster center
% exceeds this
if nargin < 4;  KLTHRESH = 10; end

if nargin < 5;  VERBOSE = 0;  end

[ndat,ndim] = size(data);

% VQ the lowest 4 dims DATA into 8 clusters
%comps = NCOMP; % 16;
%use_vq = 0;

%if use_vq
%  if VERBOSE; disp('running VQ...'); end
%  %[C,I] = vq(data, comps);
%  % stats tbx version
%  [I,C] = kmeans(data,comps);
%  
%  % Make gaussians
%  for i = 1:comps
%    model.mean(:,i) = mean(data(find(I==i),:))';
%    model.cov(:,:,i) = cov(data(find(I==i),:)); 
%    model.weight(i) = sum(I==i);
%  end
%else
  % use EM

  if VERBOSE; disp('running EM...'); end
  nits = 30;
  model = gmm_est(data, comps, nits);

%end

if VERBOSE
  %gmm_plotdata(data, model);
end

% Merge components with small determinants (compact modes)
model = gmm_mergecomponents(model, SMALLESTTHRESH, KLTHRESH, VERBOSE);

% More EM?
if 0
  nits = 5;
  model = gmm_est(data,model,nits);
  model = gmm_mergecomponents(model, SMALLESTTHRESH, KLTHRESH, VERBOSE);
end
