function gmm_print(model,vals,emph)
% gmm_print(model, emph)
%   Print out a description of a gmm structure
%   mark the component indexed by emph
% 2012-03-13 Dan Ellis dpwe@ee.columbia.edu

[ndim,clusts] = size(model.mean);

if nargin < 2; vals = []; end
if nargin < 3; emph = []; end

if length(vals) == 0
  havevals = 0;
else
  havevals = 1;
end

% describe gaussians
for i = 1:clusts
  if max(emph == i) > 0
    c = '+';
  else
    c = ' ';
  end
  str = sprintf('model %d (%.1f,%.1f) n=%f vol=%.1f ', ...
                i, model.mean(1,i), model.mean(2,i), ...
                model.weight(i), det(squeeze(model.cov(:,:,i))).^(1/ndim));
  if havevals
    str = [str, sprintf('gp=%.3f ', vals(i))];
  end
  str = [str, c];

  disp(str);
end

PRINT_DISTS = 0;
if PRINT_DISTS
  % Also display mutual distances
  gm = gmm_distance(gmm_explode(model));
  for i = 1:size(gm,1);
    fprintf(1, '%6.2f ',gm(i,:));
    fprintf(1, '\n');
  end
end

