function L = lab2_insert3(M,N)
% L = lab2_insert3(M,N)
%     Insert a set of 3 col <start end label> row entries from N
%     into a set 2 col <start label> entries in M
%     and return 2 col in L.
%     Label times are "pushed back" by each insertion.
%     Developed for the re-introduction of segments cut out by desquelch.
% 2012-05-20 DAn Ellis dpwe@ee.columbia.edu

L = M;

if size(N,1) == 0
  N = [0 0 0];
end

if size(L,1) == 0
  L = [0,0;max(N(:,2)),0];
end

for i = 1:size(N,1)
  nstart = N(i,1);
  nend = N(i,2);
  nlab = N(i,3);
  
  lpos = max(find(L(:,1) <= nstart));
  
  if L(lpos,:) < nstart
%    fprintf(1,'%f < %f\n',L(lpos,1),nstart)
    % label gets divided
    L = lab2_insert_row(L, lpos+1, L(lpos,:));
    lpos = lpos + 1;
    L(lpos,1) = nstart;
  else
%    fprintf(1,'%f == %f\n',L(lpos,1),nstart)
  end
  L = lab2_insert_row(L, lpos, [nstart, nlab]);
  ndur = nend - nstart;
  L(lpos+1:end,1) = L(lpos+1:end,1) + ndur;
  
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Y = lab2_insert_row(X,pos,row)
Y = [X(1:pos-1,:);row;X(pos:end,:)];
