function Y = labels_collarize(X,C1,C2,L)
% Y = labels_collarize(X,C1,C2,L)
%    "Expand" 3-column labels in X.
%    Starting labels are shifted earlier by C1 secs;
%    Ending labels are shifted labter by C2 secs (=C1 if empty).
%    If L is specified, only applies to labels matching elements of L.

if nargin < 3; C2 = []; end
if nargin < 4; L = []; end

if length(C2) == 0;  C2 = C1; end

if length(L) == 0
  rowstodo = 1:size(X,1);
else
  rowstodo = zeros(size(X,1),1);
  for i = 1:length(L)
    rowstodo(find(X(:,3)==L(i))) = 1;
  end
  rowstodo = find(rowstodo);
end

% Apply collar
if size(X,1) == 0
  X = [0 0 0];
end

Y = X;
Y(rowstodo,1) = max(0,Y(rowstodo,1)-C1);
Y(rowstodo,2) = min(Y(end,2),Y(:,2)+C2);

% Maybe resort & remerge?
Y = lab2col_to_lab3col(lab3col_to_lab2col(Y));
